Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 877535 - net-libs/xrootd-5.4.3-r2 fails tests (lto)
Summary: net-libs/xrootd-5.4.3-r2 fails tests (lto)
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Guilherme Amadio
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: lto
  Show dependency tree
 
Reported: 2022-10-18 06:12 UTC by Agostino Sarubbo
Modified: 2024-07-03 09:24 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (build.log,772.52 KB, text/plain)
2022-10-18 06:12 UTC, Agostino Sarubbo
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Agostino Sarubbo gentoo-dev 2022-10-18 06:12:34 UTC
https://blogs.gentoo.org/ago/2020/07/04/gentoo-tinderbox/

Issue: net-libs/xrootd-5.4.3-r2 fails tests (lto).
Discovered on: amd64 (internal ref: lto_tinderbox)

NOTE:
This machine uses lto with CFLAGS=-flto -Werror=odr -Werror=lto-type-mismatch -Werror=strict-aliasing

Here is a bit of explanation:

-Werror=lto-type-mismatch:
User to find possible runtime issues in packages. It likely means the package is unsafe to build & use with LTO.
For projects using the same identifier but with different types across different files, they must be fixed to be consistent across the codebase.

-Werror=odr:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO. C++ code must comply with the One Definition Rule (ODR) - see https://en.cppreference.com/w/cpp/language/definition#One_Definition_Rule.

-Werror=strict-aliasing:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO.

Workarounds:
- If upstream is friendly and still active, file a bug upstream. For emulators, codecs, games, or multimedia packages, it may be worth just applying a workaround instead, as upstreams sometimes aren't receptive to these bugs (VALID FOR ALL).
- Use the new 'filter-lto' from flag-o-matic.eclass as it's likely to be unsafe with LTO (VALID FOR lto-type-mismatch - odr).
- Fix it yourself if interested, of course (VALID FOR ALL).
- Append-flags -fno-strict-aliasing (VALID FOR strict-aliasing).
- Use memcpy() but a union is sometimes suitable too (VALID FOR strict-aliasing).
- -fstrict-aliasing is implied by -O2, so this must be addressed in some form (VALID FOR strict-aliasing).

See also: https://marc.info/?l=gentoo-dev&m=165639574126280&w=2
Comment 1 Agostino Sarubbo gentoo-dev 2022-10-18 06:12:37 UTC
Created attachment 824665 [details]
build.log

build log and emerge --info
Comment 2 Agostino Sarubbo gentoo-dev 2022-10-18 06:12:39 UTC
Error(s) that match a know pattern:


--   Package 'json-c', required by 'virtual:world', not found
-- Could NOT find Macaroons (missing: MACAROONS_INCLUDES MACAROONS_LIB) 
-- Could NOT find SciTokensCpp (missing: SCITOKENS_CPP_LIBRARIES SCITOKENS_CPP_INCLUDE_DIR) 
-- Could NOT find TinyXml (missing: TINYXML_LIBRARIES TINYXML_INCLUDE_DIR) 
/var/tmp/portage/net-libs/xrootd-5.4.3-r2/temp/environment: line 4470:    26 Segmentation fault      ./common/test-runner ./XrdClTests/libXrdClTests.so "All Tests/UtilsTest/"
Comment 3 Guilherme Amadio gentoo-dev 2024-03-09 17:13:40 UTC
We've completely removed cppunit tests and migrated everything to GoogleTest upstream. The ticket on GitHub is https://github.com/xrootd/xrootd/issues/2051.
Comment 4 Eli Schwartz gentoo-dev 2024-03-25 16:16:44 UTC
I actually just tried this with 5.6.7 and 5.6.9 and `ebuild ... clean test` seemed to work with LTO just fine? The migration to googletest isn't part of those releases though.
Comment 5 Guilherme Amadio gentoo-dev 2024-07-03 09:24:48 UTC
Marking this as resolved. net-libs/xrootd-5.6.7 is the oldest version in the tree now, and in 5.7.0 (released on July 1st), the cppunit tests are completely gone.